$(function() {
	setPriceFilter();

	$('body').on('click', '.js-search-filters-clear-all', function () {
		var noFilterUrl = window.location.href.replace(window.location.search,'');
		window.location = noFilterUrl;
	});

	prestashop.on('updateProductList', function () {
		setPriceFilter();
	});
});

function appendGetParam(key,value) {
	if (history.pushState) {
		var params = new URLSearchParams(window.location.search);
		params.append(key, value);
		var newUrl = window.location.protocol + "//" + window.location.host + window.location.pathname + '?' + params.toString();
		window.history.pushState({path:newUrl},'',newUrl);
	}
}

var product_range_from;
var product_range_to;

function setPriceFilter(){

	var inputPriceRange = $('.js-range-slider');

	if(document.location.search.includes('Prix')) {

		var urlPart = window.location.search.split('/');

		urlPart.forEach(function (element) {
			if(element.includes('Prix')){
				var priceRange = element.split('-');
				product_range_from = priceRange[2];
				product_range_to = priceRange[priceRange.length -1];
			}
		});
	}

	inputPriceRange.ionRangeSlider({
		min: inputPriceRange.data('min'),
		max: inputPriceRange.data('max'),
		type: "double",
		from: product_range_from,
		to: product_range_to,
		step: 1,
		grid: false,
		postfix: " "+prestashop.currency.sign,
		drag_interval: true,
		min_interval: null,
		max_interval: null,

		//TODO : automatisation pour les langues
		onStart: function (data) {
			if(document.location.href.includes('Prix')){
					$('#search_filters input[type="checkbox"]').each(function () {
						$(this).attr('data-search-url', $(this).data('search-url') + '/Prix-' + prestashop.currency.sign + '-' + data.from + '-' + data.to)
					});
				}
		},

		onFinish: function (data) {

			if(document.location.href.includes('q=Prix')){
				stePricFilterUrlParam(document.location.search,data.from, data.to);
				inputPriceRange.attr('data-search-url',document.location.href);

			} else if(!document.location.href.includes('q=Prix') && document.location.href.includes('q=')){
				if(document.location.href.includes('/Prix')){
					stePricFilterUrlParam(document.location.search,data.from,data.to);
					inputPriceRange.attr('data-search-url',document.location.href);
				} else {
					window.history.replaceState(null,null,document.location.href+'/Prix-'+prestashop.currency.sign+'-'+data.from+'-'+data.to);
					inputPriceRange.attr('data-search-url',document.location.href);
				}
			}else if(!document.location.href.includes('q=Prix')){
				appendGetParam('q','Prix-'+prestashop.currency.sign+'-'+data.from+'-'+data.to);
				inputPriceRange.attr('data-search-url',document.location.href);
			} else {
				inputPriceRange.attr('data-search-url',document.location.href);
			}

			inputPriceRange.trigger('change');
		}

	});

}

function stePricFilterUrlParam(urlSearch,from,to) {
	var urlPart = urlSearch.split('/');
	var pricePart;
	var pricePartToPush;

	urlPart.forEach(function (element) {
		if(element.includes('Prix')){
			pricePart = element;
			var priceFilterParameter = element.split('-');
			priceFilterParameter[2] = from;
			priceFilterParameter[3] = to;
			pricePartToPush = priceFilterParameter.join('-');
		}
	});
	window.history.replaceState(null,null,document.location.href.replace(pricePart,pricePartToPush));
}